﻿using AirFusion.Toast;
using AirFusionCustomToast;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Media.Imaging;

namespace AirFusion
{
	public class NotificationManager
	{
		#region Members

		private bool _isWin8Later = false;

		#endregion

		#region Properties

		private object _toastManager = null;
		public object ToastManager 
		{
			get 
			{
				return _toastManager;
			}
		}

		#endregion

		#region Events

		public event EventHandler<WindowEventArgs> WindowEvent;

		#endregion

		#region Constructors & Dispose

		public NotificationManager() 
		{
			try
			{
				// To determine current OS
				var os = Environment.OSVersion;
				if (os.Platform == PlatformID.Win32NT && (os.Version.Major > 6 || (os.Version.Major == 6 && os.Version.Minor >= 2)))
				{
					LogtoFile.WriteLog("", Configs.DebugLevelValue, "OS is Win8 or later", "");

					_isWin8Later = true;

					// it is win8 or higher.
					this._toastManager = new AFToastManager();

					//(this._toastManager as AFToastManager).ToastActivated += delegate(object sender, AFToastManager.AFToastActionActivateEventArgs args)
					//{
					//	this.SendEventAsync(this, new WindowEventArgs(WindowEventType.NotificationClicked, args.NotificationKey, args.DeviceInstanceId));
					//};

					(this._toastManager as AFToastManager).ToastDismissed += delegate(object sender, AFToastManager.AFToastActionDismissEventArgs args)
					{

					};

					(this._toastManager as AFToastManager).ToastFailed += delegate(object sender, AFToastManager.AFToastActionFailEventArgs args)
					{

					};
				}
				else if (os.Platform == PlatformID.Win32NT && (os.Version.Major == 6 && os.Version.Minor == 1))
				{
					LogtoFile.WriteLog("", Configs.DebugLevelValue, "OS is Win7 or previous", "");

					_isWin8Later = false;
				}
			}
			catch(Exception ex)
			{
				LogtoFile.WriteLog("", Configs.DebugLevelValue, ex.ToString(), "");
			}
		}

		#endregion

		#region Private Methods

		private void SendEventAsync(object sender, WindowEventArgs eventArgs)
		{
			try
			{
				if (null != this.WindowEvent)
				{
					this.WindowEvent(sender, eventArgs);
				}
			}
			catch (Exception ex)
			{
				LogtoFile.WriteLog("", Configs.DebugLevelValue, ex.ToString(), "");
			}
		}

		#endregion

		#region Public Methods

		public void CreateAndShowToast(string key, AirFusion.Manager.Notification.ToastItem item) 
		{
			if (_isWin8Later)
			{
				// it is win8 or higher.
				if (null != this._toastManager)
				{
					(this._toastManager as AFToastManager).CreateAndShowToast(key, item);
				}
			}
			else
			{
				//AirFusionCustomToast.NotificationUIElement notificationUIElement = new AirFusionCustomToast.NotificationUIElement();
				//notificationUIElement.Launchable = item.Launchable;
				//notificationUIElement.Removable = item.Removable;
				//notificationUIElement.Title = item.ToastTitle;
				//notificationUIElement.NotificationKey = key;
				//notificationUIElement.DeviceInstanceID = item.DeviceInstanceId.ToString();
				//notificationUIElement.BitmapIcon = Utils.CreateBitmapSourceByFile(item.IconPath);

				//if (null != item.ToastContent)
				//{
				//	if (item.ToastContent.Length >= 1)
				//	{
				//		notificationUIElement.ContentLine1 = item.ToastContent[0];
				//		for (int i = 1; i < item.ToastContent.Length; ++i)
				//		{
				//			notificationUIElement.ContentLine2 += item.ToastContent[i];
				//		}
				//	}
				//}


				//ToastPopUp toast = new ToastPopUp(notificationUIElement);

				//toast.ClosedByUser += delegate(object sender, EventArgs e)
				//{
					
				//};

				//toast.PressedEvent += delegate(ToastPopUp.PressedEventArgs PEA)
				//{
				//	this.SendEventAsync(this, new WindowEventArgs(WindowEventType.NotificationClicked, PEA.PressedKey, PEA.DeviceInstanceID));
				//};

				//toast.PressedEvent += delegate(ToastPopUp.PressedEventArgs PEA)
				//{
				//	this.SendEventAsync(this, new WindowEventArgs(WindowEventType.NotificationClicked, PEA.PressedKey));
				//};

				//toast.Show();
			}
		}

		#endregion
	}
}
