﻿using AirFusion.Manager.Notification;
using System;
using System.Collections.Generic;

namespace AirFusionCustomToast
{
	public class GeneralNotificationUIElement : System.ComponentModel.INotifyPropertyChanged
	{
		public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

		protected virtual void OnPropertyChanged(string propertyName)
		{
			if (this.PropertyChanged != null)
			{
				this.PropertyChanged(this, new System.ComponentModel.PropertyChangedEventArgs(propertyName));
			}
		}

		private bool _removable = false;

		public bool Removable
		{
			get
			{
				return _removable;
			}

			set
			{
				_removable = value;
				this.OnPropertyChanged("Removable");
			}
		}

		private bool _isMediaStyle = false;

		public bool isMediaStyle
		{
			get
			{
				return _isMediaStyle;
			}

			set
			{
				_isMediaStyle = value;
				this.OnPropertyChanged("isMediaStyle");
			}
		}

		private bool _isAllowMute = true;

		public bool IsAllowMute
		{
			get
			{
				return _isAllowMute;
			}

			set
			{
				_isAllowMute = value;
				this.OnPropertyChanged("IsAllowMute");
			}
		}

		private string _title = string.Empty;

		public string Title
		{
			get
			{
				return _title;
			}

			set
			{
				_title = value;
				this.OnPropertyChanged("Title");
			}
		}

		private string _appName = string.Empty;

		public string AppName
		{
			get
			{
				return _appName;
			}

			set
			{
				_appName = value;
				this.OnPropertyChanged("AppName");
			}
		}

		private string _content = string.Empty;

		public string Content
		{
			get
			{
				return _content;
			}

			set
			{
				_content = value;
				this.OnPropertyChanged("Content");
			}
		}

		private string _info = string.Empty;

		public string Info
		{
			get
			{
				return _info;
			}

			set
			{
				_info = value;
				this.OnPropertyChanged("Info");
			}
		}

		private string _notificationKey = string.Empty;

		public string NotificationKey
		{
			get
			{
				return _notificationKey;
			}

			set
			{
				_notificationKey = value;
				this.OnPropertyChanged("NotificationKey");
			}
		}

		private Guid _deviceInstanceID = Guid.Empty;

		public Guid DeviceInstanceID
		{
			get
			{
				return _deviceInstanceID;
			}

			set
			{
				_deviceInstanceID = value;
				this.OnPropertyChanged("DeviceInstanceID");
			}
		}

		private NotificationType _type = NotificationType.Basic;

		public NotificationType Type
		{
			get
			{
				return _type;
			}

			set
			{
				_type = value;
				this.OnPropertyChanged("Type");
			}
		}

		private System.Windows.Media.Imaging.BitmapSource _bitmapIcon = null;

		public System.Windows.Media.Imaging.BitmapSource BitmapIcon
		{
			get
			{
				return _bitmapIcon;
			}

			set
			{
				_bitmapIcon = value;
				this.OnPropertyChanged("BitmapIcon");
			}
		}

		private AirFusion.Manager.Notification.LocalLaunch _localLaunchHandler = null;

		public AirFusion.Manager.Notification.LocalLaunch LocalLaunchHandler
		{
			get
			{
				return _localLaunchHandler;
			}

			set
			{
				_localLaunchHandler = value;
			}
		}

		private List<AirFusion.Manager.Notification.QuickActionItem> _qaItemList = new List<AirFusion.Manager.Notification.QuickActionItem>();

		public List<AirFusion.Manager.Notification.QuickActionItem> QAItemList
		{
			get
			{
				return _qaItemList;
			}
		}
	}
}