﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;

namespace AirFusionCustomToast
{
	class GeneralNotificationHelper
	{
		[StructLayout(LayoutKind.Sequential)]
		public struct RECT
		{
			public int Left;
			public int Top;
			public int Right;
			public int Bottom;
		}

		public class ScreenDetectionn
		{
			[DllImport("user32.dll")]
			private static extern IntPtr GetForegroundWindow();
			[DllImport("user32.dll")]
			private static extern IntPtr GetDesktopWindow();
			[DllImport("user32.dll")]
			private static extern IntPtr GetShellWindow();
			[DllImport("user32.dll", SetLastError = true)]
			private static extern int GetWindowRect(IntPtr hwnd, out RECT rc);

			public static bool isForegroundWindowFullScreen()
			{
				IntPtr desktopHandle = GetDesktopWindow();
				IntPtr shellHandle = GetShellWindow();

				bool runningFullScreen = false;
				RECT appBounds;
				System.Drawing.Rectangle screenBounds;
				IntPtr hWnd;
				hWnd = GetForegroundWindow();

				if (hWnd != null && !hWnd.Equals(IntPtr.Zero))
				{
					if (!(hWnd.Equals(desktopHandle) || hWnd.Equals(shellHandle)))
					{
						GetWindowRect(hWnd, out appBounds);
						screenBounds = System.Windows.Forms.Screen.FromHandle(hWnd).Bounds;
						if ((appBounds.Bottom - appBounds.Top) == screenBounds.Height
							&& (appBounds.Right - appBounds.Left) == screenBounds.Width)
						{
							runningFullScreen = true;
						}
					}
				}

				return runningFullScreen;
			}
		} 
	}
}
