﻿//using InTheHand.Net; // 2015-05-20 Seoker: remove Bluetooth related functions since it's defeatured
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirFusion.Common
{
	/// <summary>
	/// Extensions.
	/// </summary>
	internal static partial class Extensions
	{
		/// <summary>
		/// Gets the string format of the specified instance ID.
		/// </summary>
		/// <param name="instanceID">The instance ID.</param>
		/// <returns>The string presentation.</returns>
		public static string GetStringFormat(this Guid instanceID)
		{
			return instanceID.ToString("D").ToUpper();
		}

		// 2015-05-20 Seoker: remove Bluetooth related functions since it's defeatured
		/*
		internal static string GetStringFormat(this BluetoothAddress address)
		{
			return address.ToString("C").ToUpper();
		}
		*/

		/// <summary>
		/// Gets the substring of the specified text.
		/// </summary>
		/// <param name="text">The text.</param>
		/// <param name="length">The length.</param>
		/// <returns>The substring of the specified text.</returns>
		public static string GetSubString(this string text, int length = 200)
		{
			if (text == null)
			{
				return "(null)";
			}
			else
			{
				return text.Length > length ? text.Substring(0, length) + " ..." : text;
			}
		}
	}
}
