﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AirFusion.Common.ProximityDetection
{
	/// <summary>
	/// Specifies the proximity detection method.
	/// </summary>
	public enum ProximityDetectionMethod
	{
		/// <summary>
		/// Signifies proximity detection through SoundTrigger.
		/// </summary>
		SoundTrigger,

		/// <summary>
		/// Signifies proximity detection through Bluetooth PXP.
		/// </summary>
		BluetoothPxp,

		/// <summary>
		/// Signifies not using any proximity detection.
		/// </summary>
		None
	}
}