﻿using AirFusion.Common;
using Bonjour;
using System;

namespace AirFusion.Manager.DeviceManager
{
	public partial class DnsSdHandler
	{
		/// <summary>
		/// Specifies the connection protocol.
		/// </summary>
		public enum ConnectionProtocol
		{
			/// <summary>
			/// Unknown.
			/// </summary>
			Unknown = 0,

			/// <summary>
			/// TCP.
			/// </summary>
			[ParameterValue("_tcp")]
			Tcp = 16,

			/// <summary>
			/// Any other than TCP.
			/// </summary>
			[ParameterValue("_udp")]
			Udp = 32
		}
	}

	#region Extensions

	/// <summary>
	/// Exceptions.
	/// </summary>
	internal static partial class AFExtensions
	{
		internal static DNSSDProtocol Transform(this DnsSdHandler.ConnectionProtocol protocol)
		{
			int value = (int)protocol;
			if (Enum.IsDefined(typeof(DNSSDProtocol), value))
			{
				return (DNSSDProtocol)Enum.ToObject(typeof(DNSSDProtocol), value);
			}

			return (DNSSDProtocol)0;
		}

		internal static DnsSdHandler.ConnectionProtocol Transform(this DNSSDProtocol protocol)
		{
			int value = (int)protocol;
			if (Enum.IsDefined(typeof(DnsSdHandler.ConnectionProtocol), value))
			{
				return (DnsSdHandler.ConnectionProtocol)Enum.ToObject(typeof(DnsSdHandler.ConnectionProtocol), value);
			}

			return DnsSdHandler.ConnectionProtocol.Unknown;
		}
	}

	#endregion
}
