﻿using AirFusion.Common;
using System;
using System.Text;

namespace AirFusion.Manager.DeviceManager
{
	public partial class UserDeviceManager
	{
		partial class MulticastDnsAdapter
		{
			/// <summary>
			/// Represents the event data of service lost.
			/// </summary>
			public class ServiceLostEventArgs : EventArgs
			{
				/// <summary>
				/// Gets or sets the instance.
				/// </summary>
				public MDnsInstance Instance { get; internal set; }

				/// <summary>
				/// Prevents a default instance of the <see cref="ServiceLostEventArgs"/> class from being created.
				/// </summary>
				ServiceLostEventArgs()
				{
				}

				/// <summary>
				/// Initializes a new instance of the <see cref="ServiceLostEventArgs"/> class.
				/// </summary>
				/// <param name="instance">The instance.</param>
				public ServiceLostEventArgs(MDnsInstance instance)
				{
					if (instance == null)
					{
						throw new ArgumentNullException("instance");
					}

					this.Instance = instance;
				}

				/// <summary>
				/// Returns a <see cref="System.String" /> that represents this instance.
				/// </summary>
				/// <returns>
				/// A <see cref="System.String" /> that represents this instance.
				/// </returns>
				public override string ToString()
				{
					StringBuilder builder = new StringBuilder();
					builder.AppendLine(this.GetType().GetFullName() + ".Instance: " + (this.Instance != null ? "\r\n" + this.Instance.ToString() : "N/A"));

					return builder.ToString().TrimEnd();
				}
			}
		}
	}
}
