﻿using Newtonsoft.Json;

namespace AirFusion.WebService.Adapters
{
	internal partial class DeviceInformation
	{
		public partial class ServicesInfo
		{
			public partial class ScreencastInfo
			{
				/// <summary>
				/// Represents the two dimensions of resolution.
				/// </summary>
				public struct ScreenResolution
				{
					#region Private

					private int? _width;
					private int? _height;

					#endregion Private

					/// <summary>
					/// Gets the width.
					/// </summary>
					[JsonProperty("Width")]
					public int? Width
					{
						get { return this._width; }
						internal set { this._width = value; }
					}

					/// <summary>
					/// Gets the height.
					/// </summary>
					[JsonProperty("Height")]
					public int? Height
					{
						get { return this._height; }
						internal set { this._height = value; }
					}

					/// <summary>
					/// Initializes a new instance of the <see cref="ScreenResolution"/> struct.
					/// </summary>
					/// <param name="width">The width.</param>
					/// <param name="height">The height.</param>
					public ScreenResolution(int width, int height)
					{
						this._width = width;
						this._height = height;
					}

					/// <summary>
					/// Returns a <see cref="System.String" /> that represents this instance.
					/// </summary>
					/// <returns>
					/// A <see cref="System.String" /> that represents this instance.
					/// </returns>
					public override string ToString()
					{
						return (this.Width.HasValue ? this.Width.Value.ToString() : "N/A") + "*" + (this.Height.HasValue ? this.Height.Value.ToString() : "N/A");
					}
				}
			}
		}
	}
}
