﻿using System.Net.Http;

namespace AirFusion.WebService
{
	/// <summary>
	/// Represents a web service local response filter.
	/// </summary>
	public abstract class WebServiceLocalResponseFilter : IWebServiceResponseFilter
	{
		/// <summary>
		/// Filters a local response.
		/// </summary>
		/// <param name="responseMessage">The response message, any modification could be made to this instance.</param>
		/// <returns>True if to continue next filters.</returns>
		/// <remarks>The exception thrown by this method should be considered as an error response, and stop executing next filters.</remarks>
		public abstract bool Filter(HttpResponseMessage responseMessage);
	}
}
