﻿using System.Net.Http;

namespace AirFusion.WebService
{
	/// <summary>
	/// Represents a web service remote request filter.
	/// </summary>
	public abstract class WebServiceRemoteRequestFilter : IWebServiceRequestFilter
	{
		/// <summary>
		/// Filters a remote request.
		/// </summary>
		/// <param name="requestMessage">The request message, any modification could be made to this instance.</param>
		/// <param name="responseMessage">The response message if any.</param>
		/// <returns>True if to continue next filters.</returns>
		/// <remarks>
		/// - The exception thrown by this method should be considered as an invalid request to be responsed with the exception directly.
		/// - If the output 'responseMessage' is not null, the request will be responsed with the specified 'responseMessage'.
		/// </remarks>
		public abstract bool Filter(HttpRequestMessage requestMessage, out HttpResponseMessage responseMessage);
	}
}
