#pragma once

#include <queue>
#include "PullOutputPin.h"

using namespace std;

// filter
class PullSrcFilter : public CBaseFilter, public ISourceFilter
{
	DECLARE_IUNKNOWN;

public:

	// The only allowed way to create Bouncing balls!
	static CUnknown * WINAPI CreateInstance(LPUNKNOWN lpunk, HRESULT *phr);

protected:
	// filter-wide lock
	CCritSec m_csFilter;

	// our output pin
	PullOutputPin* m_OutputPin;

	// Type we think our data is
	CMediaType m_mt;

public:
	bool      m_bReceiving;
	SOCKET    m_hSocket;
	HANDLE	  mRcvThread;

	//CCritSec m_cQueueLock;            // Lock queue

	HANDLE m_hMutex;

	//HANDLE m_gSemaphore;

	std::deque<PMPEGTS_PACK> m_dQueue;

	//0217 Johnson modify to small size ringqueue buffer size to 100KB
	//static const int RINGBUFFERSIZE = 20 * 1024 * 1024;
	static const int RINGBUFFERSIZE = 1000 * 6 * 188;
	BYTE* m_pRingBuffer;
	LONG  m_idxRecvWritePos;
	LONG  m_idxRecvWriteRound;
	LONG  m_idxOffset;

	int m_iPreRTPCount;
	int m_iTotalRTPCount;
	int m_iPreRTPTimeStamp;
	int m_iMAXReferencePacket;
	float m_fSuccessRate;
	int m_iRecvBufferSize;
	bool m_bNeedToSkip;
	bool m_bNetworkTooBad;
	queue<int> m_qRecentCount;

	//Johnson 0112 add
	//for record deliver data type
	int m_iConnectType;

	//Johnson 0122 add
	SOCKET m_hClientSocket;
	bool m_bSendToUICheck;

	//Johnon 0212 add
	bool m_bSendDummyinfo;

	//Johnson 0415 add for check save video file
	bool m_bSavePacketToFile;
	wstring m_sSavePacketPath;

public:
	//Johnson 0112 add
	//For set deliver data type and default type is UDP
	STDMETHODIMP InitialSetting(int);
	STDMETHODIMP StartReceiving(void);
	//0212 Johnon add
	//Workrun : for stop miracast play
	STDMETHODIMP SendDummyData(void);
	/*STDMETHODIMP_(ULONG) NonDelegatingAddRef();
	STDMETHODIMP_(ULONG) NonDelegatingRelease();*/
	STDMETHODIMP NonDelegatingQueryInterface(REFIID riid, void **pObj);

	STDMETHODIMP ReConnecting(int);

private:
	int Receive(SOCKET ClientSocket, char * outBuf, int inLen, int* outLen);
	static DWORD WINAPI ReceivingThrd(void * pParam);
	void ReceivingLoop(void);
	void DeleteReceiver(void);
	void SendResultMessage(bool _bCheckResult);
	void QueuePush(PMPEGTS_PACK inData);
	PMPEGTS_PACK QueuePop(void);

	void CreateUDPReceiver(void);
	void CreateTCPReceiver(void);

	void SaveToRingQueue(char * outBuf, unsigned dataLen);
	void TCPListenSocket(SOCKET ClientSocket);

	bool CheckRTPPacketLength(int packetLength);
	void PostSourceFilterDisconnectMessage();

public:
	PullSrcFilter(LPUNKNOWN lpunk, HRESULT *phr);
	~PullSrcFilter();

	// --- CBaseFilter methods ---
	int GetPinCount();
	CBasePin *GetPin(int n);

	// --- Access our media type
	const CMediaType *LoadType() const
	{
		return &m_mt;
	}

	virtual HRESULT Connect(IPin * pReceivePin, const AM_MEDIA_TYPE *pmt)
	{
		return (*m_OutputPin).CBasePin::Connect(pReceivePin, pmt);
	}

	//STDMETHODIMP Stop();
};