#include "stdafx.h"

/// <summary>
/// Bool value to decide whether to output log
/// </summary>
bool SourceFilterLogManager::m_needOutputLog(FALSE);

/// <summary>
/// Buffer for log output
/// </summary>
TCHAR SourceFilterLogManager::m_logBuffer[DEF_LOG_BUFFER_SIZE];

/// <summary>
/// Check whether to output log according to the registry key value
/// </summary>
void SourceFilterLogManager::CheckLogOutputStatus()
{
	HKEY hKey;
	LONG registryKeyOpenResult;

	registryKeyOpenResult = RegOpenKeyEx(HKEY_CURRENT_USER, DEF_REGISTRY_KEY_SOURCE_FILTER_ROOT_PATH, NULL, KEY_ALL_ACCESS, &hKey);
	if(registryKeyOpenResult == ERROR_SUCCESS)
	{
		LONG registryKeyQueryResult;
		DWORD resultData;
		DWORD outputDataBufferSize = sizeof(DWORD);
		registryKeyQueryResult = RegQueryValueEx(hKey, DEF_REGISTRY_KEY_SOURCE_FILTER_VALUE_NAME_NEED_OUTPUT_LOG, NULL, NULL, reinterpret_cast<LPBYTE>(&resultData), &outputDataBufferSize);
		if((registryKeyQueryResult == ERROR_SUCCESS) && (resultData == TRUE))
		{
			SourceFilterLogManager::m_needOutputLog = TRUE;
			return;
		}
	}
	SourceFilterLogManager::m_needOutputLog = FALSE;
}

/// <summary>
/// Function for log output
/// </summary>
/// <param name="outputLog">
/// The output log string
/// </param>
void SourceFilterLogManager::OutputLog(TCHAR *ouputLog)
{
	if(SourceFilterLogManager::m_needOutputLog)
	{
		OutputDebugString(ouputLog);
	}
}